# 2022-09-17 - Galère

Je galère depuis 3 jours avec le registre en mode Redis.

Je me tape plein d'erreurs incompréhensibles.

```
TypeError: Invalid argument type
    at encodeCommand (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/client/RESP2/encoder.js:17:19)
    at RedisCommandsQueue.getCommandToSend (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/client/commands-queue.js:187:45)
    at Commander._RedisClient_tick (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/client/index.js:440:76)
    at Commander._RedisClient_sendCommand (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/client/index.js:424:82)
    at Commander.commandsExecutor (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/client/index.js:170:154)
    at Commander.BaseClass.<computed> [as get] (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/commander.js:8:29)
    at file:///Users/jeremy.buget/Works/paastis/paastis-engine/registry/RunningAppRegistryStore.js:100:48
    at Array.reduce (<anonymous>)
    at RedisRunningAppRegistryStore.all (file:///Users/jeremy.buget/Works/paastis/paastis-engine/registry/RunningAppRegistryStore.js:99:38)
    at processTicksAndRejections (node:internal/process/task_queues:96:5)
```

Elles surviennent quand je tente de faire `_redisClient.keys('*')` dans le code.

✅ Quand je réveille une ou plusieurs apps, elles sont bien ajoutées dans Redis.

```shell
# côté shell
$ curl -v localhost:3000 -H "Host: hellofastifydeux.proxy.paastis.dev"

# côté Redis
> keys *
1) "hello-fastify"
2) "hellofastifydeux"
```

✅ Et elles suppriment bien au moment, ni trop tôt, ni trop tard.


❌ J'ai tenté d'améliorer les modules de type singleton : `./redis.js`, `registry/index.js`, etc.

❌ J'en suis à me demander si le problème ne vient pas de la clé, avec des `-`, ex : `hello-fastify-2`.
Mais d'après [la doc sur les clés](https://redis.io/docs/data-types/tutorial/#keys), c'est ok.

❌ J'ai tenté de passer par les commandes `HGETALL` et `MGET` mais elles ne font pas vraiment ce que je veux et ça ne marche pas mieux.

❌ J'en suis venu à soupçonner WebStorm.
Ou le "mode debug" de l'IDE.
Mais j'obtiens les mêmes soucis dans le terminal.

❌ J'ai regardé [les issues de `node-redis`](https://github.com/redis/node-redis/issues?q=is%3Aissue+is%3Aopen+Invalid+argument+type).

❌ J'ai modifié le `docker-compose` pour préciser qu'on utilise la dernière version de l'image Docker pour Redis `redis:latest`.

❌ J'ai foutu des `await` le plus que je pouvais suspectant un problème de chargement des modules ESM.

❌ J'ai essayé en n'utilisant que des apps Scalingo sans tiret (renommer `hello-fastify-2` en `hellofastifydeux`).

❌ J'ai tenté de redémarrer la stack `docker-compose down --remove-orphans` et de supprimer le volume `cache:/data`.

❌ J'ai tenté de passer par les attributs de classe privés en JS (`this.#_redisClient.keys('*')`).

❌ J'ai tenté de démarrer le client Redis dans le démarrage du serveur plutôt que dans le module `./redis.js`.

❌ Je me suis demandé si ce n'est pas lié de vouloir faire tourner dans un même programme Node un serveur HTTP et un CRON.

🤔 L'appli crash au moment du tick du CRON.
Je mets un try catch sur la fonction `./server.js#stopIdleApps`
À défaut de trouver la source de l'erreur, j'aimerais bien que le programme ne plante pas.
❌ Le programme continue de tomber ?!?

❌ J'ai tenté l'option `legacyMode` lors de la création du client Redis.
```javascript
client = createClient({
url: config.registry.redisUrl,
legacyMode: true
});
```

J'obtiens une erreur au démarrage :
```shell
Server is running on https://localhost:3000
SyntaxError: Unexpected token u in JSON at position 0
    at JSON.parse (<anonymous>)
    at RedisRunningAppRegistryStore.get (file:///Users/jeremy.buget/Works/paastis/paastis-engine/registry/RunningAppRegistryStore.js:84:17)
    at processTicksAndRejections (node:internal/process/task_queues:96:5)
    at async RunningAppRegistry.getApp (file:///Users/jeremy.buget/Works/paastis/paastis-engine/registry/RunningAppRegistry.js:17:18)
    at async stopIdleApps (file:///Users/jeremy.buget/Works/paastis/paastis-engine/server.js:55:28)
    at async startCron (file:///Users/jeremy.buget/Works/paastis/paastis-engine/server.js:81:3)
```
✅ Au moins le programme n'est pas crashé.
Je redémarre Redis depuis Docker.
Peut-être que le format des clés existantes n'est plus approprié.
Même erreur.

Je change l'implémentation pour tenir compte de l'existence de la donnée renvoyée.
```javascript
    const data = await this.#_redisClient.get(appName);
    if (data) {
      return JSON.parse(data);
    }
```
Ça plante un peu plus loin, non plus sur `RedisRunningAppRegistryStore#get` mais sur `RedisRunningAppRegistryStore#all`.
On fait le même changement.
✅ Le programme se lance sans crasher.
❌ Mais le résultat de `/system/apps` est toujours tableau vide. 
Je mets un point d'arrêt.

🤔 C'est bizarre :
- dans Redis : je vois mes 2 clés/entrées
- dans WebStorm : `const keys = await this.#_redisClient.keys('*')` (le résultat) vaut `undefined`.
Je me demande si le client Redis est toujours connecté.
Et si oui, si c'est à la bonne base.

💡 J'utilise la commande Redis `CLIENT LIST` qui permet de voir les clients connectés au serveur.
Je vois bien mes 2 clients :
```
id=10 addr=127.0.0.1:41982 laddr=127.0.0.1:6379 fd=8 name= age=27 idle=0 flags=N db=0 sub=0 psub=0 ssub=0 multi=-1 qbuf=26 qbuf-free=20448 argv-mem=10 multi-mem=0 rbs=1024 rbp=0 obl=0 oll=0 omem=0 tot-mem=22298 events=r cmd=client|list user=default redir=-1 resp=2
id=11 addr=172.26.0.1:57344 laddr=172.26.0.2:6379 fd=9 name= age=4 idle=4 flags=N db=0 sub=0 psub=0 ssub=0 multi=-1 qbuf=0 qbuf-free=0 argv-mem=0 multi-mem=0 rbs=1024 rbp=173 obl=0 oll=0 omem=0 tot-mem=1800 events=r cmd=set user=default redir=-1 resp=2
```

💡 J'utilise la commande Redis `CONFIG GET databases` pour lister les bases de données.
Je vois 2 bases :
```
1) "databases"
2) "16"
```
Je ne sais pas si c'est normal.
Je relance le conteneur Docker de zéro.
J'obtiens le même résultat.
Je retrouve [le même résultat sur StackOverflow](https://stackoverflow.com/a/12805364).

> Le 16 indique le nombre de bases par défaut initié par Redis.

❌ J'ai abandonné le `legacyMode`.
Ça ne fonctionne pas mieux et en plus ça pue de mettre une version moderne qui tourne depuis des mois (mai).

❌ J'ai activé l'option `disableOfflineQueue=true`.

🤔 Tant que je n'ai pas d'app active, tout se passe bien.
Dès que j'enregistre une app, j'obtiens l'erreur suivante (en node-redis v4)
```
TypeError: Invalid argument type
    at encodeCommand (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/client/RESP2/encoder.js:17:19)
    at RedisCommandsQueue.getCommandToSend (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/client/commands-queue.js:187:45)
    at Commander._RedisClient_tick (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/client/index.js:440:76)
    at Commander._RedisClient_sendCommand (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/client/index.js:424:82)
    at Commander.commandsExecutor (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/client/index.js:170:154)
    at Commander.BaseClass.<computed> [as get] (/Users/jeremy.buget/Works/paastis/paastis-engine/node_modules/@redis/client/dist/lib/commander.js:8:29)
    at file:///Users/jeremy.buget/Works/paastis/paastis-engine/registry/RunningAppRegistryStore.js:104:50
    at Array.reduce (<anonymous>)
    at RedisRunningAppRegistryStore.all (file:///Users/jeremy.buget/Works/paastis/paastis-engine/registry/RunningAppRegistryStore.js:103:40)
    at processTicksAndRejections (node:internal/process/task_queues:96:5)
```
Au moins, maintenant (depuis que j'ai foutu des `try/catch` sur la méthode `all`, le programme ne crashe plus.

J'ai l'impression de progresser.
En mode debug dans WebStorm, l'erreur semble apparaître au moment de faire `await this.#_redisClient.get(k)` dans la boucle des clés :
```javascript
  async all() {
    try {
      const keys = await this.#_redisClient.keys('*');
      if (keys) {
        const managedApps = await keys.reduce(async (k, apps) => {
          const object = await this.#_redisClient.get(k);
          if (object) {
            const app = new RunningApp(object._provider, object._name, object._region, object._startedAt, object._lastAccessedAt);
            apps.push(app);
          }
          return apps;
        }, []);
        return managedApps;
      }
      return [];
    } catch (err) {
      console.error(err);
    }
   }
```
❌ Je suspecte un problème de `this`.

**✅ J'ai trouvé 🙌 !!!**

C'était un problème "entre-la-chaise-et-le-clavier" 🤦‍♂️…
2 erreurs : 
- lors de mon `reduce`, j'ai inversé les 2 paramètres (ça m'apprendre à croire que je maîtrise JS et ne pas vérifier des détails aussi atomiques)
- suite au `redis.get`, j'ai oublié de faire un `JSON.parse`

Pfiou… 
Tout ce temps de passé pour un si petit détail…
Je ne sais pas quoi en penser.
Je vais me chercher une corde 🎚.

Il se trouve que j'avais aussi un problème de `Collection.reduce` avec des appels aynchrone dedans.
✅ J'ai sorti Bluebird et notamment [`Promise.reduce`](http://bluebirdjs.com/docs/api/promise.reduce.html).

## 🚨🚨🚨PEUT-ÊTRE QUE SI J'AVAIS EU DES PUT*** DE TESTS AUTO, JE N'AURAIS PAS PERDU 8H !!!🚨🚨

## Redis

#### Accéder au Redis CLI via Docker 

```shell
$ docker exec -it paastis-registry redis-cli
```

#### Suivre les commandes exécutées sur Redis en temps réel

```shell
127.0.0.1:6379> MONITOR
```
